<!DOCTYPE html>
<html>
  <head>
    <title>Task 40.20</title>
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css"
    />
    <!-- Data Table-->
    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css"
    />
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  </head>

  <body>
    <!-- Vùng header -->
    <div class="container">
      <div class="text-center">
        <h2>List Courses</h2>
      </div>
      <div class="form-group">
        <button class="btn btn-success" id="btn-add-course">
          <i class="fa fa-plus"></i>&nbsp; Add Course
        </button>
      </div>
    </div>
    <!-- Courses Data Table -->
    <div class="container">
      <table
        class="table table-bordered table-striped table-hover"
        id="course-table"
      >
        <thead class="thead-dark">
          <tr>
            <th scope="col">STT</th>
            <th scope="col">CourseName</th>
            <th scope="col">Duration</th>
            <th scope="col">Level</th>
            <th scope="col">Price</th>
            <th scope="col">DiscountPrice</th>
            <th scope="col">Teacher</th>
            <th scope="col">Action</th>
          </tr>
        </thead>
      </table>
    </div>
    <!-- Vùng Modal -->

    <!-- Create user modal -->
    <div>
      <div id="create-course-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">Creat new course</h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <form>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-create-coursecode">Course code</label>
                  </div>
                  <div class="col-sm-8">
                    <input
                      type="text"
                      id="input-create-coursecode"
                      name="coursecode"
                      placeholder="Course code"
                      class="form-control"
                    />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-create-coursename">Course name</label>
                  </div>
                  <div class="col-sm-8">
                    <input
                      type="text"
                      id="input-create-coursename"
                      name="coursename"
                      placeholder="Course name"
                      class="form-control"
                    />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-create-duration">Duration</label>
                  </div>
                  <div class="col-sm-8">
                    <input
                      type="text"
                      id="input-create-duration"
                      name="duration"
                      placeholder="Duration"
                      class="form-control"
                    />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="select-create-level">Level</label>
                  </div>
                  <div class="col-sm-8">
                    <select
                      name="select-create-level"
                      id="select-create-level"
                      class="form-control"
                    >
                      <option value="Beginner">Beginner</option>
                      <option value="Intermediate">Intermediate</option>
                      <option value="Advanced">Advanced</option>
                    </select>
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-create-price">Price</label>
                  </div>
                  <div class="col-sm-8">
                    <input
                      type="text"
                      id="input-create-price"
                      name="price"
                      placeholder="price"
                      class="form-control"
                    />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-create-discountPrice"
                      >Discount Price</label
                    >
                  </div>
                  <div class="col-sm-8">
                    <input
                      type="text"
                      id="input-create-discountPrice"
                      name="discountPrice"
                      placeholder="Discount price"
                      class="form-control"
                    />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-create-teacher">Teacher</label>
                  </div>
                  <div class="col-sm-8">
                    <input
                      type="text"
                      id="input-create-teacher"
                      name="teacher"
                      placeholder="Teacher"
                      class="form-control"
                    />
                  </div>
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <button
                class="btn btn-secondary"
                id="btn-insert-cancel"
                data-dismiss="modal"
              >
                Cancel
              </button>
              <button class="btn btn-primary" id="btn-insert-course">
                Insert Course
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- Update user modal -->
    <div>
      <div id="update-course-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">Update user</h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <form>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-update-coursecode">Course code</label>
                  </div>
                  <div class="col-sm-8">
                    <input
                      type="text"
                      id="input-update-coursecode"
                      name="coursecode"
                      placeholder="Course code"
                      class="form-control"
                    />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-update-coursename">Course name</label>
                  </div>
                  <div class="col-sm-8">
                    <input
                      type="text"
                      id="input-update-coursename"
                      name="coursename"
                      placeholder="Course name"
                      class="form-control"
                    />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-update-duration">Duration</label>
                  </div>
                  <div class="col-sm-8">
                    <input
                      type="text"
                      id="input-update-duration"
                      name="duration"
                      placeholder="Duration"
                      class="form-control"
                    />
                  </div>
                </div>

                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="select-update-level">Level</label>
                  </div>
                  <div class="col-sm-8">
                    <select
                      name="select-update-level"
                      id="select-update-level"
                      class="form-control"
                    >
                      <option value="Beginner">Beginner</option>
                      <option value="Intermediate">Intermediate</option>
                      <option value="Advanced">Advanced</option>
                    </select>
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-update-price">Price</label>
                  </div>
                  <div class="col-sm-8">
                    <input
                      type="text"
                      id="input-update-price"
                      name="price"
                      placeholder="price"
                      class="form-control"
                    />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-update-discountPrice"
                      >Discount Price</label
                    >
                  </div>
                  <div class="col-sm-8">
                    <input
                      type="text"
                      id="input-update-discountPrice"
                      name="discountPrice"
                      placeholder="Discount price"
                      class="form-control"
                    />
                  </div>
                </div>

                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-update-teacher">Teacher</label>
                  </div>
                  <div class="col-sm-8">
                    <input
                      type="text"
                      id="input-update-teacher"
                      name="teacher"
                      placeholder="Teacher"
                      class="form-control"
                    />
                  </div>
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <button
                class="btn btn-secondary"
                id="btn-insert-cancel"
                data-dismiss="modal"
              >
                Cancel
              </button>
              <button class="btn btn-primary" id="btn-update-course">
                Update Course
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- Delete user modal -->
    <div>
      <div id="delete-course-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">
                Confirm delete course
              </h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <form>
                <div class="row form-group">
                  <div class="col-sm-12">
                    <p>Bạn có chắc chắn muốn xóa course?</p>
                  </div>
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <button class="btn btn-danger" id="btn-delete-course">
                Confirm Course
              </button>
              <button
                class="btn btn-secondary"
                id="btn-delete-cancel"
                data-dismiss="modal"
              >
                Cancel
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
  </body>

  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    const gBASE_URL = "https://624abe0dfd7e30c51c110ac6.mockapi.io/api/v1/";
    const gCONTENT_TYPE = "application/json;charset=UTF-8";

    //biến toàn cục để lưu trữ id user đang được update
    var gCourseId = 0;

    var gSTT = 1;

    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    const gCOURSES_COLS = [
      // "stt",
      "courseCode",
      "courseName",
      "duration",
      "level",
      "price",
      "discountPrice",
      "teacherName",
      "action",
    ];

    // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    // const gCOURSE_STT_COL = 0;
    const gCOURSE_CODE_COURSE_COL = 0;
    const gCOURSE_NAME_COURSE_COL = 1;
    const gCOURSE_DURATION_COL = 2;
    const gCOURSE_LEVEL_COL = 3;
    const gCOURSE_PRICE_COL = 4;
    const gCOURSE_DISCOUNT_PRICE_COL = 5;
    const gCOURSE_TEACHER_COL = 6;
    const gCOURSE_ACTION_COL = 7;

    // Khai báo DataTable & mapping collumns
    var gCourseTable = $("#course-table").DataTable({
      columns: [
        // { data: gCOURSES_COLS[gCOURSE_STT_COL] },
        { data: gCOURSES_COLS[gCOURSE_CODE_COURSE_COL] },
        { data: gCOURSES_COLS[gCOURSE_NAME_COURSE_COL] },
        { data: gCOURSES_COLS[gCOURSE_DURATION_COL] },
        { data: gCOURSES_COLS[gCOURSE_LEVEL_COL] },
        { data: gCOURSES_COLS[gCOURSE_PRICE_COL] },
        { data: gCOURSES_COLS[gCOURSE_DISCOUNT_PRICE_COL] },
        { data: gCOURSES_COLS[gCOURSE_TEACHER_COL] },
        { data: gCOURSES_COLS[gCOURSE_ACTION_COL] },
      ],
      columnDefs: [
        // {
        //   // định nghĩa lại cột STT
        //   targets: gCOURSE_STT_COL,
        //   className: "text-center text-info",
        //   render: function (data, type, row, meta) {
        //     return meta.row + meta.settings._iDisplayStart + 1;
        //   },
        // },
        {
          // định nghĩa lại cột
          targets: gCOURSE_CODE_COURSE_COL,
          className: "text-center",
        },
        {
          // định nghĩa lại cột
          targets: gCOURSE_NAME_COURSE_COL,
          className: "text-center",
        },
        {
          // định nghĩa lại cột
          targets: gCOURSE_DURATION_COL,
          className: "text-center",
        },
        {
          // định nghĩa lại cột
          targets: gCOURSE_LEVEL_COL,
          className: "text-center",
        },
        {
          // định nghĩa lại cột
          targets: gCOURSE_PRICE_COL,
          className: "text-center",
        },
        {
          // định nghĩa lại cột
          targets: gCOURSE_DISCOUNT_PRICE_COL,
          className: "text-center",
        },
        {
          // định nghĩa lại cột
          targets: gCOURSE_TEACHER_COL,
          className: "text-center",
        },
        {
          // định nghĩa lại cột action
          targets: gCOURSE_ACTION_COL,
          className: "text-center",
          defaultContent: `
                  <button class="btn btn-link" data-toggle="tooltip" data-placement="bottom" title="Update course" id="update-course"><i class="fas fa-edit text-success"></i></button>
                  <button class="btn btn-link btn-sm" data-toggle="tooltip" data-placement="bottom" title="Delete course" id="delete-course"><i class="fas fa-trash-alt text-danger"></i></button>`,
        },
      ],
    });

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
      // thực hiện tải trang
      onPageLoading();

      //gán sự kiện add new - 1 course
      $("#btn-add-course").on("click", function () {
        onBtnAddNewCourseClick(this);
      });

      //gán sự kiện Update - Sửa 1 course
      $("#course-table").on("click", "#update-course", function () {
        onBtnEditCourseClick(this);
      });
      //gán sự kiện Delete - Xoá 1 course
      $("#course-table").on("click", "#delete-course", function () {
        onBtnDeleteCourseClick(this);
      });
      //gán sự kiện insert course
      $("#btn-insert-course").on("click", function () {
        onBtnInsertCourseToTable();
      });
      //gán sự kiện update course
      $("#btn-update-course").on("click", function () {
        onBtnUpdateCourseToTable();
      });
      //gán sự kiện delete course
      $("#btn-delete-course").on("click", function () {
        onBtnDeleteCourseToTable();
      });
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm thực thi khi trang được load
    function onPageLoading() {
      // 1 - R: Read / Load User to DataTable
      getAllCourses();
    }

    // Hàm xử lý sự kiện khi icon edit user trên bảng đc click
    function onBtnEditCourseClick(paramBtnEdit) {
      gCourseId = getCourseIdFromButton(paramBtnEdit);
      console.log("Nút sửa được nhấn");
      console.log("Id của course là: " + gCourseId);
      //load data into form
      getUserById(gCourseId);
      // hiển thị modal lên
      $("#update-course-modal").modal("show");
    }
    // Hàm xử lý sự kiện khi icon edit User trên bảng đc click
    function onBtnDeleteCourseClick(paramBtnDelete) {
      gCourseId = getCourseIdFromButton(paramBtnDelete);
      console.log("Nút xóa được nhấn");
      console.log("Id của course là: " + gCourseId);
      //load data into form
      getUserById(gCourseId);
      // hiển thị modal lên
      $("#delete-course-modal").modal("show");
    }

    function onBtnAddNewCourseClick(paramBtnDelete) {
      // hiển thị modal trắng lên
      $("#create-course-modal").modal("show");
    }

    function onBtnInsertCourseToTable() {
      //khai báo đối tượng
      var vCourseObj = {
        courseCode: "",
        courseName: "",
        duration: "",
        level: "",
        price: "",
        discountPrice: "",
        teacherName: "",
      };

      //thu thập dữ liệu từ form
      readDataFromModal(vCourseObj);

      //kiểm tra dữ liệu
      var vIsCheck = validateData(vCourseObj);
      if (vIsCheck) {
        $.ajax({
          url: gBASE_URL + "/courses",
          type: "POST",
          contentType: gCONTENT_TYPE,
          data: JSON.stringify(vCourseObj),
          success: function (paramRes) {
            // B4: xử lý front-end
            handleInsertCourseSuccessFormCreate();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          },
        });
      }
    }

    function onBtnUpdateCourseToTable() {
      //khai báo đối tượng
      var vCourseObj = {
        courseCode: "",
        courseName: "",
        duration: "",
        level: "",
        price: "",
        discountPrice: "",
        teacherName: "",
      };

      //thu thập dữ liệu từ form
      readDataFromUpdateModal(vCourseObj);

      //kiểm tra dữ liệu
      var vIsCheck = validateData(vCourseObj);
      if (vIsCheck) {
        $.ajax({
          url: gBASE_URL + "/courses/" + gCourseId,
          type: "PUT",
          contentType: gCONTENT_TYPE,
          data: JSON.stringify(vCourseObj),
          success: function (paramRes) {
            // B4: xử lý front-end
            handleInsertcourseSuccessFormUpdate();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          },
        });
      }
    }

    function onBtnDeleteCourseToTable() {
      $.ajax({
        url: gBASE_URL + "/courses/" + gCourseId,
        type: "DELETE",
        contentType: gCONTENT_TYPE,
        success: function (paramVouchers) {
          handleDeleteCourseSuccess();
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        },
      });
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm gọi api để lấy all danh sách course đăng ký
    function getAllCourses() {
      $.ajax({
        url: gBASE_URL + "/courses",
        type: "GET",
        success: function (paramCourses) {
          loadDataToCourseTable(paramCourses);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        },
      });
    }
    /** load course array to DataTable
     * in: course array
     * out: course table has data
     */
    function loadDataToCourseTable(paramCourseArr) {
      gCourseTable.clear();
      gCourseTable.rows.add(paramCourseArr);
      gCourseTable.draw();
    }

    //hàm dựa vào button detail (edit or delete) xác định được id user
    function getCourseIdFromButton(paramButton) {
      var vTableRow = $(paramButton).parents("tr");
      var vCourseRowData = gCourseTable.row(vTableRow).data();
      return vCourseRowData.id;
    }

    // hàm get user by id
    function getUserById(paramCourseId) {
      $.ajax({
        url: gBASE_URL + "/courses/" + paramCourseId,
        type: "GET",
        success: function (paramCourse) {
          showCourseDataToModalUpdate(paramCourse);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        },
      });
    }

    //thu thập dữ liệu nhập vào insert course
    function readDataFromModal(paramCourseObj) {
      paramCourseObj.courseCode = $("#input-create-coursecode").val().trim();
      paramCourseObj.courseName = $("#input-create-coursename").val().trim();
      paramCourseObj.duration = $("#input-create-duration").val().trim();
      paramCourseObj.level = $("#select-create-level").val();
      paramCourseObj.price = $("#input-create-price").val().trim();
      paramCourseObj.discountPrice = $("#input-create-discountPrice")
        .val()
        .trim();
      paramCourseObj.teacherName = $("#input-create-teacher").val().trim();
    }

    //hàm kiểm tra dữ liệu insert user
    function validateData(paramCourseObj) {
      if (paramCourseObj.courseCode === "") {
        alert("Course code chưa được nhập.");
        return false;
      }
      if (paramCourseObj.courseCode.length < 5) {
        alert("Course code phải chứa hơn 5 kí tự.");
        return false;
      }
      if (paramCourseObj.courseName === "") {
        alert("Course name chưa được nhập.");
        return false;
      }
      if (paramCourseObj.courseName.length < 5) {
        alert("Course name phải chứa hơn 5 kí tự.");
        return false;
      }
      if (paramCourseObj.duration === "") {
        alert("Duration chưa được nhập.");
        return false;
      }
      if (paramCourseObj.price === "") {
        alert("Price chưa được nhập.");
        return false;
      }
      if (isNaN(paramCourseObj.price)) {
        alert("Price nhập phải là số.");
        return false;
      }
      if (paramCourseObj.discountPrice === "") {
        alert("Discount Price chưa được nhập.");
        return false;
      }
      if (isNaN(paramCourseObj.discountPrice)) {
        alert("Discount Price nhập phải là số.");
        return false;
      }
      if (paramCourseObj.discountPrice >= paramCourseObj.price) {
        alert("Discount Price phải nhỏ hơn price.");
        return false;
      }
      if (paramCourseObj.teacherName === "") {
        alert("Teacher name chưa được nhập.");
        return false;
      }
      return true;
    }

    //xử lý sự kiện khi nhấn nút button tạo course
    function handleInsertCourseSuccessFormCreate() {
      alert("Thêm course thành công!");
      getAllCourses();
      resetCreateCourseForm();
      $("#create-course-modal").modal("hide");
    }

    //hàm xóa trắng form create course
    function resetCreateCourseForm() {
      $("#input-create-coursename").val("");
      $("#input-create-duration").val("");
      $("#select-create-level").val("Beginner");
      $("#input-create-price").val("");
      $("#input-create-discountPrice").val("");
      $("#input-create-teacher").val("");
    }

    //hàm thu thập dữ liệu form update modal
    function readDataFromUpdateModal(paramCourseObj) {
      paramCourseObj.courseCode = $("#input-update-coursecode").val().trim();
      paramCourseObj.courseName = $("#input-update-coursename").val().trim();
      paramCourseObj.duration = $("#input-update-duration").val().trim();
      paramCourseObj.level = $("#select-update-level").val();
      paramCourseObj.price = $("#input-update-price").val().trim();
      paramCourseObj.discountPrice = $("#input-update-discountPrice")
        .val()
        .trim();
      paramCourseObj.teacherName = $("#input-update-teacher").val().trim();
    }

    //xử lý sự kiện khi nhấn nút button update course
    function handleInsertcourseSuccessFormUpdate() {
      alert("Cập nhật course thành công!");
      getAllCourses();
      resetCreateCourseForm();
      $("#update-course-modal").modal("hide");
    }

    //hàm hiển thị course ra form
    function showCourseDataToModalUpdate(paramCourse) {
      $("#input-update-coursename").val(paramCourse.courseName);
      $("#input-update-duration").val(paramCourse.duration);
      $("#select-update-level").val(paramCourse.level);
      $("#input-update-price").val(paramCourse.price);
      $("#input-update-discountPrice").val(paramCourse.discountPrice);
      $("#input-update-teacher").val(paramCourse.teacherName);
    }

    //xử lý sự kiện khi nhấn nút button delete course
    function handleDeleteCourseSuccess() {
      alert("Xác nhận đã xóa course thành công!");
      getAllCourses();
      resetCreateCourseForm();
      $("#delete-course-modal").modal("hide");
    }
  </script>
</html>
